﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ErrorHandlingInWF
{
	public class ConsoleMenu
	{
        Dictionary<string, Action> actions;
        int selectedOption = 0; 

        public ConsoleMenu(Dictionary<string, Action> options)
        {
            actions = options;
        }


        public void Run()
        {
            DisplayChoices();
            ReadInput();
            ExecutionChoice();
        }

        private void ReadInput()
        {
            string input = Console.ReadLine();
            int option = 0;
            while(!int.TryParse(input, out option))
            {
                Console.WriteLine("You must enter a valid integer and press Enter");
                input = Console.ReadLine();
            }

            selectedOption = option;
        }

        private void ExecutionChoice()
        {
            string key = actions.Keys.Skip(selectedOption - 1).Take(1).First();
            Action selectedAction = actions[key];
            Console.WriteLine("\n  Executing option ({0})\n", key);
            selectedAction();
        }

        private void DisplayChoices()
        {
            Console.WriteLine("Select an option:");

            int choiceIndex = 1;
            foreach (string key in actions.Keys)
            {
                Console.WriteLine("{0}: {1}", choiceIndex++, key);
            }

            Console.Write("\nEnter your choice: ");
        }


	}
}
