﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.ComponentModel;
using System.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.ComponentModel.Design;

namespace CustomActivities
{
    [Designer(typeof(SequenceDesigner), typeof(IDesigner))]
	public class CustomSequence : CompositeActivity
	{
        int index = 0;

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            if (EnabledActivities.Count == 0)
                return ActivityExecutionStatus.Closed;

            Activity child = EnabledActivities[index];

            child.Closed += new EventHandler<ActivityExecutionStatusChangedEventArgs>(child_Closed);
            child.Faulting += new EventHandler<ActivityExecutionStatusChangedEventArgs>(child_Faulting);
            executionContext.ExecuteActivity(child);

            return ActivityExecutionStatus.Executing;

        }

        void child_Faulting(object sender, ActivityExecutionStatusChangedEventArgs e)
        {
            Console.WriteLine("Child {1} faulting: {0}", this.ExecutionStatus, e.Activity.Name);
            e.Activity.Faulting -= child_Faulting;
        }

        void child_Closed(object sender, ActivityExecutionStatusChangedEventArgs e)
        {
            e.Activity.Closed -= child_Closed;

            ActivityExecutionContext ctx = sender as ActivityExecutionContext;

            Console.WriteLine("Child closed: {0}", this.ExecutionStatus);
            if (++index == EnabledActivities.Count )
            {
                ctx.CloseActivity();

            }
            else
            {
                if (this.ExecutionStatus == ActivityExecutionStatus.Executing)
                {
                    Activity child = EnabledActivities[index];

                    child.Closed += new EventHandler<ActivityExecutionStatusChangedEventArgs>(child_Closed);
                    child.Faulting += new EventHandler<ActivityExecutionStatusChangedEventArgs>(child_Faulting);
                    ctx.ExecuteActivity(child);
                }
            }

        }


        protected override ActivityExecutionStatus HandleFault(ActivityExecutionContext executionContext, Exception exception)
        {
            Console.WriteLine("Sequence Handling Fault");
            return base.HandleFault(executionContext, exception);
        }

        protected override ActivityExecutionStatus Cancel(ActivityExecutionContext executionContext)
        {
            Console.WriteLine("Sequence Canceling");
            return base.Cancel(executionContext);
        }
	}
}
