﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.ComponentModel;
using System.ComponentModel;

namespace ErrorHandlingInWF
{
	public class CustomThrowActivity : Activity
	{

        [Category("Retry")]
        public int NumberOfTimesToThrow { get; set; }

        [Category("Retry")]
        public string ExceptionText { get; set; }


        public static DependencyProperty ThrowIndicatorProperty = DependencyProperty.Register("ThrowIndicator", typeof(int), typeof(CustomThrowActivity));

        [System.ComponentModel.DescriptionAttribute("ThrowIndicator")]
        [Category("Retry")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public int ThrowIndicator
        {
            get
            {
                return ((int)(base.GetValue(CustomThrowActivity.ThrowIndicatorProperty)));
            }
            set
            {
                base.SetValue(CustomThrowActivity.ThrowIndicatorProperty, value);
            }
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            if (ThrowIndicator++ < NumberOfTimesToThrow)
                throw new ApplicationException(ExceptionText);
            else
            {
                Console.WriteLine("Custom throw NOT throwing exception");
            }
            return ActivityExecutionStatus.Closed;
        }

        protected override ActivityExecutionStatus HandleFault(ActivityExecutionContext executionContext, Exception exception)
        {
            Console.WriteLine("Handling fault in CustomThrow");
            return base.HandleFault(executionContext, exception);
        }
	}
}
