﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.ComponentModel;

namespace ErrorHandlingInWF
{
	public class LogActivity: Activity
	{
        public static DependencyProperty ExceptionToLogProperty = DependencyProperty.Register("ExceptionToLog", typeof(Exception), typeof(LogActivity));

        [System.ComponentModel.DescriptionAttribute("ExceptionToLog")]
        [System.ComponentModel.CategoryAttribute("ExceptionToLog Category")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public Exception ExceptionToLog
        {
            get
            {
                return ((Exception)(base.GetValue(LogActivity.ExceptionToLogProperty)));
            }
            set
            {
                base.SetValue(LogActivity.ExceptionToLogProperty, value);
            }
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            Console.ForegroundColor = ConsoleColor.Red;

            Console.WriteLine(ExceptionToLog.Message);

            Console.ResetColor();
            return ActivityExecutionStatus.Closed;
        }
	}
}
