﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace ErrorHandlingInWF
{
    public sealed partial class ManualRetryLogic : SequentialWorkflowActivity
    {
        private bool retryFlag = true;
        private bool hasExceptionOccured = false;


        public ManualRetryLogic()
        {
            InitializeComponent();
        }

        public static DependencyProperty customThrowIndicatorProperty = DependencyProperty.Register("customThrowIndicator", typeof(System.Int32), typeof(ErrorHandlingInWF.ManualRetryLogic));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Retry")]
        public Int32 customThrowIndicator
        {
            get
            {
                return ((int)(base.GetValue(ErrorHandlingInWF.ManualRetryLogic.customThrowIndicatorProperty)));
            }
            set
            {
                base.SetValue(ErrorHandlingInWF.ManualRetryLogic.customThrowIndicatorProperty, value);
            }
        }

        private void CheckThrowResult(object sender, ConditionalEventArgs e)
        {
            e.Result = !hasExceptionOccured;
        }

        private void TurnOffRetry_ExecuteCode(object sender, EventArgs e)
        {
            retryFlag = false;
        }

        private void EnsureRetry_ExecuteCode(object sender, EventArgs e)
        {
            retryFlag = true;
            hasExceptionOccured = false;
        }

        private void codeActivity1_ExecuteCode(object sender, EventArgs e)
        {
            hasExceptionOccured = true;
        }
    }

}
