﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.ComponentModel;

namespace ErrorHandlingInWF
{
	public class WriteLineActivity : Activity
	{
        public static DependencyProperty OutputTextProperty = DependencyProperty.Register("OutputText", typeof(string), typeof(WriteLineActivity));

        [System.ComponentModel.DescriptionAttribute("OutputText")]
        [System.ComponentModel.CategoryAttribute("OutputText Category")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public string OutputText
        {
            get
            {
                return ((string)(base.GetValue(WriteLineActivity.OutputTextProperty)));
            }
            set
            {
                base.SetValue(WriteLineActivity.OutputTextProperty, value);
            }
        }

        public ConsoleColor ForegroundColor { get; set; }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            Console.ForegroundColor = ForegroundColor;
            Console.WriteLine(OutputText);
            Console.ResetColor();
            return ActivityExecutionStatus.Closed;
        }
	}
}
